/*
 * ȨϢ: Copyright (c) ſƼ޹˾
 * ļ: test_pskc.c
 * ļ: ֤ؽӿڲԳ
 * ʱ    : 2011-12-05
 * ժ    Ҫ:
 *     : ţʤ
 *     : 1.0
 */

#include <stdio.h>

#include "ftauthng.h"

static int
test_load_seed( char *file )
{
    int          ret    = FT_API_SUCC;
    void        *tk_ctx = NULL;
    unsigned int i      = 0;
    unsigned int recs   = 0;
    StTokenData  rec;

    /* ķʽ */
    if ( FT_API_SUCC != ( ret = init_pskc( file,
                                           NULL,
                                           NULL,
                                           &tk_ctx,
                                           &recs ) ) )
    {
        printf( "init_pskc err: %d, seed file: %s\n",
                ret,
                file );

        return -1;
    }

    printf( "[%s] contain seeds: %u\n",
            file,
            recs );

    for ( i = 0;
          i < recs;
          i++ )
    {
        if ( FT_API_SUCC != (ret = read_pskc_rec( tk_ctx,
                                                  &rec,
                                                  i ) ) )
        {
            printf( "read_pskc_rec err: %d\n",
                    ret );

            continue;
        }

        /* ӡ */
        printf( "private data: %s\n",
                rec.priv_data );

        decode_pdata( &rec );
        dump_pdata( &rec.pdata );
    }

    uninit_pskc( tk_ctx );
    return 0;
}

int
main( int   argc,
      char *argv[] )
{
	/*    ļ ֹ */
    if ( 2 > argc )
    {
        printf( "parameter err\n" );

        return -1;
    }

    return test_load_seed( argv[1] );
}
