/*
 * ȨϢ: Copyright (c) ſƼ޹˾
 * ļ: test_stat.c
 * ļ: ֤ؽӿڲԳ
 * ʱ    : 2011-12-05
 * ժ    Ҫ:
 *     : ţʤ
 *     : 1.0
 */

#include "ftauthng.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

#define TOTP_SN "0000000003"

#define TOTP_PDATA_STR	"gQAKMDAwMDAwMDAwMxRWVYqACeqvQ3oeHhTcpl/GLyQLFCpuAAACBgAAAAA" \
						"AADwAAAAAAAAAAAAAO5rKAHc1lAAACv////8AAAAAAAAAAAAAAAAAAAAAAA" \
						"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAgYAAAAFngWHhtPQ1JBL" \
						"TE6SE9UUC1TSEExLTg6UU4wOC1UMU0bT0NSQS0xOkhPVFAtU0hBMS04OlFO" \
						"NjQtVDFNF09DUkEtMTpIT1RQLVNIQTEtODpRTjA4AAAAAAAAAAAAAAAAABZk"

#define TEST_PIN "1234"

/* ˽ݽṹ */
StTokenData pdata;

/* Ƽ */
int test_enable_token()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* 趨û, һΪк */
    if ( FT_API_SUCC != ( ret = set_user_login( &pdata,
                                                TOTP_SN ) ) )
    {
        printf( "set_user_login err: %d\n", ret );
        return ret;
    }
    printf( "set_user_login ok\n" );

    /* PIN */
    if ( FT_API_SUCC != (ret = set_pin( &pdata,
                                        TEST_PIN ) ) )
    {
        printf( "set_pin err: %d\n", ret );
        return ret;
    }
    printf( "set_pin ok\n" );

    /*  */
    if ( FT_API_SUCC != (ret = enable_token( &pdata ) ) )
    {
        printf( "enable_token err: %d\n", ret );
        return ret;
    }
    printf( "enable_token ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
test_set_nextmode_threshold()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* ö̬Դ */
    if ( FT_API_SUCC != ( ret = set_nextmode_threshold( &pdata,
                                                        5 ) ) )
    {
        printf( "set_nextmode_threshold err: %d\n", ret );
        return ret;
    }
    printf( "set_nextmode_threshold ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
test_set_wnd()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* ôֵ
     * Ĭ¼ƣС - 40д - 100󴰿 - 200
     * ĬʱƣС - 2 д - 4  󴰿 - 40
     */
    if ( FT_API_SUCC != ( ret = set_wnd( &pdata,
                                         6,
                                         16,
                                         26 ) ) )
    {
        printf( "set_wnd err: %d\n", ret );
        return ret;
    }
    printf( "set_wnd ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
test_get_puk()
{
    int  ret = FT_API_SUCC;
    char puk[PUK_SIZE];
	char chlg[65] = {'\0'};

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /*  */
    if ( FT_API_SUCC != ( ret = enable_token( &pdata ) ) )
    {
        printf( "enable_token err: %d\n", ret );
        return ret;
    }
    printf( "enable_token ok\n" );

	//gen_chlg(&pdata,chlg);

    /* ȡһ */
    if ( FT_API_SUCC != ( ret = get_puk( &pdata,NULL,
                                         puk ) ) )
    {
        printf( "get_puk err: %d\n", ret );
        return ret;
    }
    printf( "get_puk ok: %s\n", puk );

    /* ȡ */
    if ( FT_API_SUCC != ( ret = get_puk2( &pdata,NULL,
                                          puk ) ) )
    {
        printf( "get_puk2 err: %d\n", ret );
        return ret;
    }
    printf( "get_puk2 ok: %s\n", puk );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
test_disable_token()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* ע */
    if ( FT_API_SUCC != ( ret = disable_token( &pdata ) ) )
    {
        printf( "disable_token err: %d\n", ret );
        return ret;
    }
    printf( "disable_token ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
main( int   argc,
      char *argv[] )
{
    /* ò˽, ʵʶӦΪݱTK_PRIVATE_DATA */
    strcpy( pdata.priv_data, TOTP_PDATA_STR );

    test_enable_token();
    test_set_nextmode_threshold();
    test_set_wnd();
    test_get_puk();
    test_disable_token();

    return 0;
}
