/*
 * ȨϢ: Copyright (c) ſƼ޹˾
 * ļ: test_mobile.c
 * ļ: ֤ؽӿڲԳ
 * ʱ    : 2011-12-05
 * ժ    Ҫ:
 *     : ţʤ
 *     : 1.0
 */

#include "ftauthng.h"

#include <string.h>
#include <stdio.h>
#include <time.h>

#define  TEST_PIN "1234"

#define TOTP_PDATA_STR "gQAKbWIxMDAwMDAwMgpXV4mEDOyoS3MfdIkAAAcGAAAAAAAAAAAAAAA" \
						"AAAAAAABO5pWAWE86AAAK/////wAAAAAAAAAAAAAAAAAAAAAAAAAAA" \
						"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" \
						"AAAAAAAAAAAAAAF2g"

#define TOTP_SN "mb10000002"

/* ˽ݽṹ */
StTokenData pdata;

/* Ƽ */
int test_enable_token()
{
    int  ret = FT_API_SUCC;

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    /* 趨û, һΪк */
    if ( FT_API_SUCC != ( ret = set_user_login( &pdata,
                                                TOTP_SN ) ) )
    {
        printf( "set_user_login err: %d\n", ret );
        return ret;
    }
    printf( "set_user_login ok\n" );

    /* PIN */
    if ( FT_API_SUCC != (ret = set_pin( &pdata,
                                        TEST_PIN ) ) )
    {
        printf( "set_pin err: %d\n", ret );
        return ret;
    }
    printf( "set_pin ok\n" );

    /*  */
    if ( FT_API_SUCC != (ret = enable_token( &pdata ) ) )
    {
        printf( "enable_token err: %d\n", ret );
        return ret;
    }
    printf( "enable_token ok\n" );

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֻ */
int
test_gen_ac()
{
    int  ret = FT_API_SUCC;
    char ac[AC_MAX_SIZE];

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    if ( FT_API_SUCC !=
         ( ret = gen_ac( &pdata,
                         "52959411985640755269",
                         "123456",
                         ac ) ) )
    {
        printf( "gen_ac err: %d\n", ret );
    }
    else
    {
        printf( "gen_ac ok, ac: %s\n", ac );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

/* ֻ */
int
test_gen_cipher()
{
    int  ret = FT_API_SUCC;
    char ac[AC_MAX_SIZE];

    /* ȽַתΪṹ */
    decode_pdata( &pdata );

    if ( FT_API_SUCC !=
         ( ret = gen_ac_cipher( &pdata,
                                "52959411985640755269",
                                "123456",
                                "951753",
                                ac ) ) )
    {
        printf( "gen_ac_cipher err: %d\n", ret );
    }
    else
    {
        printf( "gen_ac_cipher ok, ac: %s\n", ac );
    }

    /* ƽṹ± */
    encode_pdata(&pdata);
    return ret;
}

int
main( int   argc,
      char *argv[] )
{
    /* ò˽, ʵʶӦΪݱTK_PRIVATE_DATA */
    strcpy( pdata.priv_data, TOTP_PDATA_STR );

    test_enable_token();
    test_gen_ac();
    test_gen_cipher();

    return 0;
}
